#
# Common make rules for Watt-32 programs except djgpp versions.
# Used only by makefiles under .\bin\ (not in .\bin\ itself).
# These makefile requires a Borland compatible make tool (maker.exe
# works best).
#
# For djgpp2 targets look at "djcommon.mak"
#
# For Watcom386 targets one of these DOSX-extender must be defined:
#
#WDOSX_EXTENDER   = 1
#PHARLAP_EXTENDER = 1
#PMODEW_EXTENDER  = 1
 DOS4GW_EXTENDER  = 1


!if !$d(SRC)
!error SRC not defined. Define SRC = C-files.. before including COMMON.MAK
!endif

!if !$d(BORLAND_EXE)
!error BORLAND_EXE not defined.
!endif

!if !$d(PHARLAP_EXP)
!error PHARLAP_EXP not defined.
!endif

!if !$d(WATCOM_EXE)
!error WATCOM_EXE not defined.
!endif


#########################################################################

.AUTODEPEND

MMODEL        = l
BCC_CFLAGS    = -c -m$(MMODEL) -v -O -f87 -H=$(TEMP)\bcc.sym
WCC386_CFLAGS = -mf -3r -w5 -zq -d2 -fpi -fr=nul -bt=dos -oilrt
WCC86_CFLAGS  = -ml -w5 -d2 -zq -zm -fr=nul -bt=dos
HC386_CFLAGS  = -w4 -c -g -O2 -586 -Hsuffix=.o32 -Hnocopyr -Hturboerr \
                -Hpragma=stack_size_warn(5000) -Hpragma=Offwarn(572)

INC   = ..\..\inc
LIB   = ..\..\lib

OBJ16 = $(SRC:.c=.obj)      # .obj files are for Borland C      (large model)
OBJ32 = $(SRC:.c=.o32)      # .o32 files are for Metaware HighC (flat model)
WO32  = $(SRC:.c=.wo)       # .wo files are for Watcom386 C     (flat model)

EXES  = $(BORLAND_EXE) $(PHARLAP_EXP) $(WATCOM_EXE)

all:  $(EXES)


#
# Borland C (large model) target
#
$(BORLAND_EXE): bcc.arg $(OBJ16)
                bcc.exe -e$(BORLAND_EXE) @&&|
                -ml -v -ls -L $(LIB)\wattcpb$(MMODEL).lib $(OBJ16)
|


#
# Metaware HighC / Pharlap target
#
$(PHARLAP_EXP): hc386.arg $(OBJ32)
                386link.exe -exe $(PHARLAP_EXP) @&&|
                  $(OBJ32)
                  -lib $(LIB)\wattcphf $(EXTRA_HCLIB)
                  -lib hc386, hc387, hcna, dosx32, dos32, exc_hc
                  -symbols -offset 1000h -stack 50000h -386 -twocase
                  -nostub -unprivileged -fullwarn -maxdata 0 -fullseg
                  -publist both -purge none *
                  -mapnames 30 -mapwidth 132 -pack
                  -attributes class code er
                  -attributes class data rw
                  -attributes class stack rw
|


#
# Watcom386 / DOS4GW target
#
$(WATCOM_EXE): wcc386.arg $(WO32) wlink.arg
               wlink @wlink.arg

wlink.arg: makefile ..\common.mak
           @copy &&|
             libpath $(WATCOM)\lib386
             libpath $(WATCOM)\lib386\dos
!if "$(DOS4GW_EXTENDER)" == "1"
             system dos4g 
!endif
!if "$(PMODEW_EXTENDER)" == "1"
             system pmodew
             option osname='PMODE/W', stub=$(LIB)\pmodew.exe
             format os2 le
!endif
!if "$(WDOSX_EXTENDER)" == "1"
             !error unfinished
!endif
!if "$(PHARLAP_EXTENDER)" == "1"
             !error unfinished
!endif
             debug all sort global
             option quiet, map, verbose, caseexact, stack=500k, eliminate
             file $(WO32:.wo =.wo,)
             name $(WATCOM_EXE)
             library $(LIB)\wattcpwf.lib
| $<



#
# .c -> object rules
#

.c.obj:    
           bcc.exe @bcc.arg {$*.c }

.c.o32:    
           hc386.exe @hc386.arg {$*.c }

.c.wo:
           wcc386.exe @wcc386.arg $*.c -fo=$*.wo


bcc.arg:   makefile ..\common.mak
           @copy &&|
             $(COMMON_DEFS) -D__WATT32__ -DWATT32 -I$(INC)
             $(BCC_CFLAGS)
             $(BCC_DEFS)
| $<

hc386.arg: makefile ..\common.mak
           @copy &&|
             $(COMMON_DEFS) -D__WATT32__ -DWATT32 -I$(INC)
             $(HC386_CFLAGS)
             $(HC386_DEFS)
| $<

wcc386.arg: makefile ..\common.mak
           @copy &&|
             $(COMMON_DEFS) -D__WATT32__ -DWATT32 -I$(INC)
             $(WCC386_CFLAGS)
             $(WCC386_DEFS)
| $<

clean:
           @del *.obj
           @del *.o32
           @del *.wo
           @del *.map
           @del bcc.arg
           @del hc386.arg
           @del wcc386.arg
           @del wlink.arg
           @del make*.@@@

scrub:     clean
           @del $(BORLAND_EXE)
           @del $(PHARLAP_EXP)
           @del $(WATCOM_EXE)

